<?php
#-------------------------------------------------------------------------
# Module: FRTaxes - A simple example frontend form module
# Version: 1.0, calguy1000 <calguy1000@hotmail.com>
#
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
# The module's homepage is: http://dev.cmsmadesimple.org/projects/skeleton/
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
if( !isset($gCms) ) exit;
if( !$this->VisibleToAdminUser() ) exit;

if( \cge_param::exists($params,'setastax') ) {
    try {
        \CGEcommerceBase\setup_manager::set_tax_calculator( $this->GetName() );
        echo $this->ShowMessage($this->Lang('msg_setastax'));
    }
    catch( \Exception $e ) {
        echo $this->ShowErrors($e->GetMessage());
    }
}
if( \cge_param::exists($params,'submit') ) {
    $newtaxes = array();
    foreach( $params['tax_name'] as $oldname => $newname ) {
        if( empty($newname) ) continue;
        $rate = \cge_string::to_float( $params['tax_rate'][$oldname] );
        if( $rate <= 0.00 || $rate > 0.4 ) continue;

        $obj = new frtaxes_taxprofile($newname,$rate);
        if( isset($params['tax_products'][$oldname]) ) $obj->set_applies_to(line_item::ITEMTYPE_PRODUCT);
        if( isset($params['tax_services'][$oldname]) ) $obj->set_applies_to(line_item::ITEMTYPE_SERVICE);
        if( isset($params['tax_shipping'][$oldname]) ) $obj->set_applies_to(line_item::ITEMTYPE_SHIPPING);
        $newtaxes[] = $obj;
    }

    $str = '';
    if( count($newtaxes) > 4 ) {
        echo $this->ShowErrors($this->Lang('error_only4taxes'));
    } else {
        $str = serialize($newtaxes);
        $this->SetPreference('taxinfo',$str);
        echo $this->ShowMesasge($this->Lang('msg_prefs_saved'));
    }
}

$taxes = array();
$str = $this->GetPreference('taxinfo');
if( $str ) $taxes = unserialize($str);

$records = array();
if( count($taxes) ) {
    foreach( $taxes as &$one ) {
        $records[] = clone $one;
    }
}

$obj = new frtaxes_taxprofile('NEW',0.00);
$records[] = $obj;

$tpl = $this->CreateSmartyTemplate('defaultadmin.tpl');
$tpl->assign('taxrecords',$records);
$tpl->display();
