<?php
#-------------------------------------------------------------------------
# Module: FRTaxes - A simple example frontend form module
# Version: 1.0, calguy1000 <calguy1000@hotmail.com>
#
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
# The module's homepage is: http://dev.cmsmadesimple.org/projects/skeleton/
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------

class frtaxes_taxprofile
{
  private $_name;
  private $_rate;
  private $_appliesto;

  public function __construct($name,$rate)
  {
    $this->_name = $name;
    $this->_rate = $rate;
  }

  public function get_name()
  {
    return $this->_name;
  }

  public function set_name($name)
  {
    $this->_name = $name;
  }

  public function get_rate()
  {
    return $this->_rate;
  }

  public function set_rate($rate)
  {
    $this->_rate = (float)$rate;
  }

  public function for_products()
  {
    if( !is_array($this->_appliesto) ) return TRUE;
    if( in_array(line_item::ITEMTYPE_PRODUCT,$this->_appliesto) ) return TRUE;
    return FALSE;
  }

  public function for_services()
  {
    if( !is_array($this->_appliesto) ) return TRUE;
    if( in_array(line_item::ITEMTYPE_SERVICE,$this->_appliesto) ) return TRUE;
    return FALSE;
  }

  public function for_shipping()
  {
    if( !is_array($this->_appliesto) ) return TRUE;
    if( in_array(line_item::ITEMTYPE_SHIPPING,$this->_appliesto) ) return TRUE;
    return FALSE;
  }

  public function set_applies_to($flag)
  {
    if( !is_array($this->_appliesto) ) $this->_appliesto = array();
    if( !in_array($flag,$this->_appliesto) ) $this->_appliesto[] = $flag;
  }

  public function applies_to($flag)
  {
    if( !is_array($this->_appliesto) ) return TRUE;
    if( in_array($flag,$this->_appliesto) ) return TRUE;
    return FALSE;
  }
}

#
# EOF
#
?>