<?php
namespace FRTaxes;

class tax_calculator implements \CGEcommerceBase\tax_calculator
{
    private $_mod;

    public function __construct( \FRTaxes $mod )
    {
        $this->_mod = $mod;
    }

    public function GetName() { return $this->_mod->GetName(); }

    protected function get_taxes()
    {
        $taxes = null;
        $str = $this->_mod->GetPreference('taxinfo');
        if( !$str ) return;
        $taxes = unserialize($str);
        if( !is_array($taxes) || count($taxes) < 1 ) return;
        return $taxes;
    }

    public function IsConfigured()
    {
        return ($this->get_taxes());
    }

    public function set_source_location( \cg_ecomm_company_address $addr ) {}
    public function set_dest_location( \cge_address $addr ) {}

    public function calculate_taxes( \cg_ecomm_cartitem $item )
    {
        $taxes = $this->get_taxes();

        $out = null;
        foreach( $taxes as $tax ) {
            $rate = $tax->get_rate();
            switch( $item->get_type() ) {
            case $item::TYPE_PRODUCT:
                if( $tax->for_products() ) $out[$tax->get_name()] = round($item->get_item_total() * $rate,2);
                break;
            case $item::TYPE_SERVICE:
                if( $tax->for_services() ) $out[$tax->get_name()] = round($item->get_item_total() * $rate,2);
                break;
            case $item::TYPE_SHIPPING:
                if( $tax->for_shipping() ) $out[$tax->get_name()] = round($item->get_item_total() * $rate,2);
                break;
            }
        }
        return $out;
    }

} // class